/**********************************************************************
 
	Copyright (C) 2003 Hirohisa MORI <joshua@nichibun.ac.jp>
 
	This program is free software; you can redistribute it 
	and/or modify it under the terms of the GLOBALBASE 
	Library General Public License (G-LGPL) as published by 

	http://www.globalbase.org/
 
	This program is distributed in the hope that it will be 
	useful, but WITHOUT ANY WARRANTY; without even the 
	implied warranty of MERCHANTABILITY or FITNESS FOR A 
	PARTICULAR PURPOSE.

**********************************************************************/



#include	"xlerror.h"
#include	"xl.h"
#include	"xl_server.h"

XL_SEXP * xl_Sync();

void
init_Sync(XLISP_ENV * env)
{
	set_env(env,l_string(std_cm,"Sync"),
		get_func_prim(xl_Sync,FO_APPLICATIVE,0,1,1));
}



XL_SEXP *
xl_Sync(XLISP_ENV * env,XL_SEXP * s,XLISP_ENV * a_env,XL_SYM_FIELD * sf)
{
int type;
XL_INTERPRETER * xli;
	type = 1;
	for ( ; sf ; sf = sf->next ) {
		if ( l_strcmp(sf->name,l_string(std_cm,"type")) == 0 ) {
			if ( l_strcmp(sf->data,l_string(std_cm,"on"))
					== 0 )
				type = 1;
			else 	type = 0;
		}
	}
	xli = get_my_xli();
	if ( type ) {
		xli->flags &= ~XIF_ASYNC;
		return n_get_string("sync");
	}
	else {
		xli->flags |= XIF_ASYNC;
		return n_get_string("async");
	}
}

